/*
 * Copyright (C) 2014 digitalSTROM.org, Schlieren, Switzerland
 *
 * Authors: Andreas Fenkart, <andreas.fenkart@dev.digitalstrom.org>
 *
 * digitalSTROM ds485-client library is free software: you can redistribute it
 * and/or modify it under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation, either version 3 of the License,
 * or (at your option) any later version.
 *
 * digitalSTROM ds485-client library is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with digitalSTROM ds485-client library. If not, see
 * <http://www.gnu.org/licenses/>.
 */

#ifndef __BASE_NET_H__
#define __BASE_NET_H__

#include <stdbool.h>

/**
 * get port number of local socket
 */
int get_local_port(int socket, int *port);

/**
 * socket_connect -- connect to service on host, until success or abort is
 * false
 * @host - hostname or "127.0.0.1" notation
 * @service - 'telnet' or port number
 * @protocol - "tcp" / "udp"
 * @cancel - will abort retry if cancel is true
 */
int socket_connect(char *host, char *service, char *protocol, bool *cancel);

#endif
